#define ALPH_2 0.2
#define PRINT  0
void readisl(char *newisl, struct cluster *tisl, float ***** ten, float *pa, int *ncl);

void readisl(char *newisl, struct cluster *tisl, float ***** ten, float *pa, int *ncl)
{

  int i,j,icen,jcen ;
  char line[200], fname[100];
  char onech;
  int ncen=NCEN ;
  int k, ii,jj,npair, icl ;
  float alpha=ALPH_2 ,ww, b0,b1,b2;

  ifstream isl(newisl) ;
  *ncl = 0;
  isl.getline( line, sizeof(line) ) ;
  while (!isl.eof()) {
    // CLUSTER   8128   8  12
    if  ( strncmp(line,"CLUSTER",7)==0 ) {
      ++(*ncl);   // this keyword starts a new cluster
      icl = *ncl - 1;
      sscanf(line+7,"%d%d%d",&(tisl[icl].ID),&(tisl[icl].L),&(tisl[icl].Lwi));
      tisl[icl].ohang = (tisl[icl].Lwi - tisl[icl].L)/2 ;
      if (PRINT) cout << "CLUSTER  " << tisl[icl].ID << " " << tisl[icl].L << " " << tisl[icl].Lwi << " " << tisl[icl].ohang << endl ;
    }
    // MDACUT    44.00
    else if  ( strncmp(line,"MDACUT",6)==0 ) {
      sscanf(line+6,"%f",&(tisl[icl].mdacut));
      if (PRINT) cout << "MDACUT " << tisl[icl].mdacut << endl;
    }
    // DMECUT     1.20
    else if  ( strncmp(line,"DMECUT",6)==0 ) {
      sscanf(line+6,"%f",&(tisl[icl].dmecut));
      if (PRINT) cout << "DMECUT " << tisl[icl].dmecut << endl;
    }
    // LINEARFIT -12.99220 1.06252  b2
    else if  ( strncmp(line,"LINEARFIT",9)==0 ) {
      sscanf(line+9,"%f%f%f",&b0,&b1,&b2);   
      if (PRINT) cout << "LINEARFIT " << b0 << " " << b1 << " " << b2 << endl;
      tisl[icl].b0 = b0; tisl[icl].b1 = b1; tisl[icl].b2 = b2;
    }
    // COVARWEIGHT 0.92479
    else if  ( strncmp(line,"COVARWEIGHT",11)==0 ) {
      sscanf(line+11,"%f",&ww);
      if (PRINT) cout << "COVARWEIGHT " << ww << endl;
      tisl[icl].ww = ww; 
    }
    // PARADIGM  1hgxA    19
    else if  ( strncmp(line,"PARADIGM",8)==0 ) {
      sscanf(line+10,"%4s %c%d",tisl[icl].pcode,&(tisl[icl].pchain),&(tisl[icl].pstart));
      if (PRINT) cout << "PARADIGM " << tisl[icl].pcode << " " << tisl[icl].pchain << " " <<  tisl[icl].pstart << endl;
    }
    // ANGLES
    else if  ( strncmp(line,"ANGLES",6)==0 ) { 
      tisl[icl].phi = new float [tisl[icl].L];
      tisl[icl].psi = new float [tisl[icl].L];
      tisl[icl].omg = new float [tisl[icl].L];
      for (ii=0; ii<tisl[icl].L; ++ii) {
        isl >> jj >> tisl[icl].phi[ii] ;
        isl >>       tisl[icl].psi[ii] ;
        isl >>       tisl[icl].omg[ii] ;
        if (PRINT) cout << "ANGLES " << jj << " " ;
        if (PRINT) cout << tisl[icl].phi[ii] <<  " " ;
        if (PRINT) cout << tisl[icl].psi[ii] << " " ;
        if (PRINT) cout << tisl[icl].omg[ii] << endl ;
      }
    }
    // PROFILE
    else if  ( strncmp(line,"PROFILE",7)==0 ) {
      tisl[icl].Wi = new float *[tisl[icl].Lwi];
      for (i=0;i<tisl[icl].Lwi;i++) tisl[icl].Wi[i] = new float [20];
      tisl[icl].Pr = new float *[tisl[icl].Lwi];
      for (i=0;i<tisl[icl].Lwi;i++) tisl[icl].Pr[i] = new float [20];
      for (ii=0; ii<tisl[icl].Lwi; ++ii) {
        isl >> jj ;
        if (PRINT) cout << setw(4) << jj ;
        for (jj=0; jj<20; ++jj) {
          isl >> tisl[icl].Pr[ii][jj] ;
          if (PRINT) cout << setw(6) << setprecision(4) << setiosflags(ios::fixed) << tisl[icl].Pr[ii][jj] ;
        }
        if (PRINT) cout << endl ;
        if (PRINT) cout << "LLR= " ;
        for (jj=0; jj<20; ++jj) {
          tisl[icl].Wi[ii][jj] = log((tisl[icl].Pr[ii][jj] + alpha*pa[jj])/(pa[jj]*(1+alpha)));
          if (PRINT) cout << setw(6) << setprecision(2) << setiosflags(ios::fixed) << tisl[icl].Wi[ii][jj] ;
        }
        if (PRINT) cout << endl ;
      }
    }
    else if  ( strncmp(line,"COVARTENSOR",11)==0 ) {
      ten[icl] = new float *** [tisl[icl].L];
      for (ii=0; ii<tisl[icl].L; ++ii) {
        ten[icl][ii] = new float ** [tisl[icl].L];
        for (jj=0; jj<tisl[icl].L; ++jj) {
          ten[icl][ii][jj] = new float * [ncen];
          for (icen=0; icen<ncen; ++icen) {
            ten[icl][ii][jj][icen] = new float [ncen];
            for (jcen=0; jcen<ncen; ++jcen) {
              ten[icl][ii][jj][icen][jcen] = 0.0;
            }
          }
        }
      }
      npair = (tisl[icl].L)*(tisl[icl].L - 1)/2 ;
      for (k=0; k<npair; ++k) {
        isl >> i;
        isl >> j;
        if (PRINT) cout << i << " " << j << endl ;
        for (icen=0; icen<ncen; icen++) {
          for (jcen=0; jcen<ncen; jcen++) {
            isl >> ten[icl][i-1][j-1][icen][jcen] ;       
            ten[icl][j-1][i-1][jcen][icen] =  ten[icl][i-1][j-1][icen][jcen] ; 
            if (PRINT) cout << setw(6) << setprecision(3) << setiosflags(ios::fixed) ;
            if (PRINT) cout << ten[icl][j-1][i-1][jcen][icen]  ;
          }
          if (PRINT) cout << endl;
        }    
      }
    }
    else if  ( strncmp(line,"TRAININGSET",11)==0 ) {
      strcpy(fname,line+11) ;
      cout << "Trainingset was " << fname << endl;
    }
    else if  ( strncmp(line,"BACKGROUND",10)==0 ) {
      for (k=0;k<20;++k) {
        sscanf(line+11+8*k,"%f",pa+k);
      }
      // if (PRINT) {
        cout << "Background amino acid probabilities from " << fname << endl;
        for (k=0;k<20;++k) {
          cout << setw(6) << setprecision(3) << setiosflags(ios::fixed) ;
          cout << pa[k];
        }
        cout << endl;
      // }
    }
    isl.getline( line, sizeof(line) ) ;
  }
}

